QGIS Application - Bug report #1854
qgisinterpolator.cpp causing build error on OS X
2009-08-01 08:58 AM - John Tull

Status: Closed

Priority: Low

Assignee: nobody -

Category: Build/Install

Affected QGIS version: Regression?: No
Operating System: OS X Easy fix?: No
Pull Request or Patch supplied: Resolution: fixed
Crashes QGIS or corrupts data: Copied to github as #: 11914
Description

From the most current svn, | cannot build successfully on OS X. The error message is:

[ 68%] Building CXX object src/plugins/interpolation/CMakeFiles/interpolationplugin.dir/qgstininterpolator.o
/Users/jctull/sources/qgis/trunk/src/plugins/interpolation/qgstininterpolator.cpp: In member function ‘int
[[QgsTINInterpolator]]::insertData(QgsFeature*, bool, int, [QgsInterpolator]]::InputType):
/Users/jctull/sources/qgis/trunk/src/plugins/interpolation/qgstininterpolator.cpp:159: error: ‘isnan’ was not declared in this scope
maker2: * [src/plugins/interpolation/CMakeFiles/interpolationplugin.dir/qgstininterpolator.o] Error 1

maker1: [src/plugins/interpolation/CMakeFiles/interpolationplugin.dir/all] Error 2

make: ** [all] Error 2

History

#1 - 2009-08-01 10:22 AM - William Kyngesburye

| just tried building after commit:7bc1aé4e (SVN r11239), using the Xcode build -- same error.

#2 - 2009-08-01 12:45 PM - William Kyngesburye

P.S. it's also showing up in ggsinterpolator.cpp.

#3 - 2009-08-01 08:59 PM - Gary Sherman

Cmake build works fine on OS X for me at commit:06ce0aa4 (SVN r11243)

#4 - 2009-08-02 08:57 AM - William Kyngesburye

OK, | see that isnan has been in ggsinterpolator.cpp since February (fixed for OSX in March), and | haven't had a problem with it. Now isnan was added to
qgstininterpolator.cpp, and now both of them complain about isnan...

John - | believe you are using Qt 4.5, right? | just updated to Qt 4.5 this weekend (right before commit:5d9b66fa (SVN r11212), which added isnan to the
tin source). And it's interesting that at first | only got 1 isnan error, but after commit:7bc1a64e (SVN r11239) | got errors in both.

Gary - which Qt version are you using?

That's the only major change in my setup that | can think of.
#5 - 2009-08-02 09:28 AM - John Tull

William - | was coming to that same realization. | was about to post a similar comment about gt versions as well. I'm using 4.5.2, fwiw.

#6 - 2009-08-02 09:53 AM - William Kyngesburye

... but then, as | recall you've been using Qt 4.5 for a while, and this is the first time you've had this error? When did you update to 4.5.2 (from 4.5.0 or .1)?

When was the last time you compiled Qgis?

#7 - 2009-08-02 10:01 AM - John Tull

| recall communicating with the dev of this plugin a while back. When it did not get fixed, | removed it from the plugins cmakefile, so | was not trying to build

it for some time. | am guessing that the cmakefile changed when the osm plugin was added to the repo over the past week or so. It has been a problem

since it was introduced into the codebase, which was after switching to qt-4.5.x, for me. Everything but this compiled fine using your xcode project

yesterday. About a week or two ago, prior to that, for my last build.

#8 - 2009-08-04 08:53 AM - William Kyngesburye

[jef] wrote on the dev list:

| hitp.//trac.0sgeo.org/geos/ticket/270 might also relate to that.
| Does replacing

| #include <cmath>

| with

| #include <math.h>

in src/core/qqgis.h help?

...now I'm back to the original error John had, just in tininterpolator. So interpolator is doing something right so that isnan works. Or tininterpolator is

including another header that includes <cmath> (the trail was too tangled for me to follow).

As a test, | changed isnan() in tininterpolator to std::isnan() and it compiled. Doing the same for interpolator breaks with:

So there seems to be some sort of namespace issue in tininterpolator, or <cmath> is included somewhere.

#9 - 2009-08-04 01:09 PM - Marco Hugentobler

I think it is because qggstininterpolator.h includes [[DualEdgeTriangulation]].h and that includes [[MathULtlis]].h (which includes <cmath>).
Could you try to add the ifdef clause
#ifndef Q_OS_MACX
#include <cmath>
#else

#include <math.h>

]
to [[MathUtils]].h and tell me if it works?

Marco

#10 - 2009-08-04 03:43 PM - William Kyngesburye

...and in Point3D.h and Vector3D.h. Then it compiles.

2
Summary: change #include <cmath> in ggis.h, [[MathUtils]].h, Point3D.h and Vector3D.h to:

#ifndef Q_OS_MACX
#include <cmath>
#else

#include <math.h>
#endif

#11 - 2009-08-04 03:50 PM - William Kyngesburye
... though the qgis.h change is global (the rest of Qgis compilation seems to be OK with it). Everything else in Qgis works with <cmath> for math functions.

It would be nice to figure out why only tininterpolation has this problem.

#12 - 2009-08-05 06:26 AM - Marco Hugentobler
- Resolution set to fixed
- Status changed from Open to Closed

| think the '#include <cmath>'in qgis.h is not used anywhere. So | removed it and added the ifdefs in commit:3ddd1795 (SVN r11275). Please reopen this
bug if there are still compile problems with the modifications.
